Subject: [Megaco] SDP attribute "a=imageattr:": (1) wildcarding [3GPP CT4 "SIS-CT"]

From: "Schwarz, Albrecht (Albrecht)" <[email-masked]>
Date: Wed, 7 Aug 2013 10:06:39 +0000

Hi Nevenka, all,
you proposed to continue the technical discussion at next CT4 meeting; like to suggest to start in parallel the clarification of  raised H.248 aspects .

The first topic is related to SDP wildcarding:

RFC 6236 allows wildcard usage for multiple attribute parameters.
I think we may just focus on the high level SDP format:

      a=imageattr:PT send attr-list recv attr-list

The wildcard "*" (ALL) may be applied principally for multiple attribute elements (in red), right?

      a=imageattr:PT send attr-list recv attr-list

e.g., PT:
A wild card (*) can be specified for the payload type number to indicate that it applies
      to all payload types in the media description.

You mentioned (in the CT4 discussion) wildcard usage at the level of
1) PT
2) recv attr-list
as far as I remember, and the PT type wildcard is the difficult one, because affecting possibly multiple media configurations, right?

My initial comments and understanding would be:
1.      A "PT level" wildcard would imply multiple (reserved) media configurations, i.e., usage of ReserveGroup.
2.      A "recv attr-list" level wildcard would enforce the MG to reply the choosen/supported attribute values
3.      Like to suggest you specify the SDP wildcarding of this attribute in H.248.39, because
a.       the wildcard "*" is applicable for SIP signalling, whereas the SDP mapping to H.248 allows principally also to use additional wildcards (here e.g., "$" and "-");
            and
b.      possible interactions with ReserveValue/ReserveGroup.
4.      Example from 26.114 ("I've copied one below"):
      26.116 is not using the "PT level" wildcard at all, because there's just a single video codec (H.264) considered by 26.114, - right?

Regards,
Albrecht
_______
SIP/SDP example (26.114):
Table A.4.10a: Example SDP offer for H.264/AVC with image size negotiation
SDP offer
a=tcap:1 RTP/AVPF
m=video 49154 RTP/AVP 99
a=pcfg:1 t=1
b=AS:315
b=RS:0
b=RR:2500
a=rtpmap:99 H264/90000
a=fmtp:99 packetization-mode=0; profile-level-id=42e00c; \
     sprop-parameter-sets=J0LgDJWgUH6Af1A=,KM46gA==
a=imageattr:99 send [x=176,y=144] [x=224,y=176] [x=272,y=224] [x=320,y=240] recv [x=176,y=144] [x=224,y=176] [x=272,y=224,q=0.6] [x=320,y=240]
a=rtcp-fb:* trr-int 5000
a=rtcp-fb:* nack
a=rtcp-fb:* nack pli
a=rtcp-fb:* ccm fir
a=rtcp-fb:* ccm tmmbr
a=extmap:4 urn:3gpp:video-orientation

---

From: "Schwarz, Albrecht (Albrecht)" <[email-masked]>
Date: Wed, 7 Aug 2013 10:21:02 +0000

The 2nd discussion subject was related to revised SDP O/A elements:

RFC 6236 explicitly indicates their (= RFC 5939 & RFC 6871) usage (see clause 3.2.6/RFC 6236).
...
      a=mcap:1 video H264/90000
      a=acap:1 imageattr:%1% send [x=720,y=576,sar=[0.91,1.0,1.09,1.45]]
      ...

Also 26.114 indicates (RFC 5939) usage in the example:
...
a=tcap:1

The general comment made in the CT4 meeting:  the mapping of these SDP elements from SIP to H.248 would need to take the work of H.248.80 into account (due to the different resource reservation principles at SIP and H.248 interfaces).

-Albrecht

From: [email-masked] [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Mittwoch, 7. August 2013 12:07
To: ext Nevenka Biondic; [email-masked]; [email-masked]
Subject: [Megaco] SDP attribute "a=imageattr:": (1) wildcarding [3GPP CT4 "SIS-CT"]

Hi Nevenka, all,

e.g., PT:

Regards,
Albrecht
_______

a=tcap:1 RTP/AVPF
m=video 49154 RTP/AVP 99
a=pcfg:1 t=1
b=AS:315
b=RS:0
b=RR:2500
a=rtpmap:99 H264/90000

---

From: Christian Groves <[email-masked]>
Date: Thu, 08 Aug 2013 18:55:03 +1000

Hello Albrecht,

I wasn't part of the discussions so I'm not 100% what was being proposed.

I'm not sure using "*" for the PT would require the use of reserve 
value/group. My understanding is that it is simple shorthand if you have 
a list of payload. A MGC could provide an over specified list of 
payloads and utilise a=imageattr:*. The MG could response with a single 
payload and still have a=imageattr:* .

With respect to using "*" in the recv attr-list I'm not sure what this 
would indicate from a H.248 perspective. There seems to be a clash 
between the RFC6236 and the H.248 usage. RFC6236 indicates that "*" 
indicates that the user sees no reason to use the image attribute. 
Whereas the H.248 wildcard usage it would mean use "all" the values. I 
think this interaction is useful to specify. From a H.248 wildcarding 
perspective it would seem that "-" truly means the MGC doesn't care and 
"$" would mean provide a value.

There's also the issue of mapping the SDP to the local and remote 
descriptors. I take it that for H.248 you only specify a=imageattr:PT 
send attr-list or a=imageattr:PT recv attr-list depending on the descriptor.

Regards, Christian

On 7/08/2013 8:21 PM, Schwarz, Albrecht (Albrecht) wrote:
>
> The 2^nd discussion subject was related to revised SDP O/A elements:
>
> …
> The general comment made in the CT4 meeting: the mapping of these SDP 
> elements from SIP to H.248 would need to take the work of H.248.80 
> into account (due to the different resource reservation principles at 
> SIP and H.248 interfaces).
>
> -Albrecht
>
> *From:[email-masked] [mailto:[email-masked]] *On 
> Behalf Of *Schwarz, Albrecht (Albrecht)
> *Sent:* Mittwoch, 7. August 2013 12:07
> *To:* ext Nevenka Biondic; [email-masked]; [email-masked]
> *Subject:* [Megaco] SDP attribute "a=imageattr:": (1) wildcarding 
> [3GPP CT4 "SIS-CT"]
>
> Hi Nevenka, all,
>
> you proposed to continue the technical discussion at next CT4 meeting; 
> like to suggest to start in parallel the clarification of raised H.248 
> aspects .
>
> The wildcard “*” (ALL) may be applied principally for multiple 
> attribute elements (in red), right?
>
> as far as I remember, and the PT type wildcard is the difficult one, 
> because affecting possibly multiple media configurations, right?
>
> 1.A “PT level” wildcard would imply multiple (reserved) media 
> configurations, i.e., usage of ReserveGroup.
>
> 2.A “recv attr-list” level wildcard would enforce the MG to reply the 
> choosen/supported attribute values
>
> 3.Like to suggest you specify the SDP wildcarding of this attribute in 
> H.248.39, because
>
> a.the wildcard “*” is applicable for SIP signalling, whereas the SDP 
> mapping to H.248 allows principally also to use additional wildcards 
> (here e.g., “$” and “-“);
> and
>
> b.possible interactions with ReserveValue/ReserveGroup.
>
> 4.Example from 26.114 (“I’ve copied one below”):
> 26.116 is not using the “PT level” wildcard at all, because there’s 
> just a single video codec (H.264) considered by 26.114, - right?
>
> Regards,
>
> Albrecht
>
> _______
>
> *Table A.4.10a: Example SDP offer for H.264/AVC with image size 
> negotiation*
>
> *SDP offer*
>
> a=tcap:1 RTP/AVPF
>
> m=video 49154 RTP/AVP 99
>
> a=pcfg:1 t=1
>
> b=AS:315
>
> b=RS:0
>
> b=RR:2500
>
> a=rtpmap:99 H264/90000
>
> a=imageattr:99 send [x=176,y=144] [x=224,y=176] [x=272,y=224] 
> [x=320,y=240] recv [x=176,y=144] [x=224,y=176] [x=272,y=224,q=0.6] 
> [x=320,y=240]
>
> a=rtcp-fb:* trr-int 5000
>
> a=rtcp-fb:* nack
>
> a=rtcp-fb:* nack pli
>
> a=rtcp-fb:* ccm fir
>
> a=rtcp-fb:* ccm tmmbr
>
> _______________________________________________
> Megaco mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/megaco

---

From: "Schwarz, Albrecht (Albrecht)" <[email-masked]>
Date: Thu, 8 Aug 2013 15:04:54 +0000

Thanks Christian for you evaluation and further insights!

Concerning 3GPP Iq, I guess that both wildcarding levels need to be described:

"PT level" wildcard: expected not to be used at IMS call control level (due to single video codec); thus the IMS-ALG shall not use "PT wildcarding" as well at gateway control level

"attr level" wildcard: guess "$" and "-" both are applicable, dependent on the use case (IMS-AGW either agnostic to video processing or the IMS-AGW is requested for some kind of "video transcoding" (which might be "video transsizing" here)).

Nevenka, could you please indicate your specific points?

I think its not so simply just to check out H.248.1 wildcarding usage and command.reply rules. It was observed that wildcarding at the level of H.248-embedded SDP needs carefull consideration, that's H.248.39 was established to describe wildcarding at SDP level in more detail.

Further: I would appreciate if you could transform the 26.114 SIP/SDP example on an H.248 command request.
Just considering a single (H.248) Stream Endpoint/Termination might not be sufficient because the IMS-AGW must compare the two Stream Descriptors of each SEP/Termination (see above ... agnostic vs video specific support ...).

Regards,
Albrecht 

-----Original Message-----
From: Christian Groves [mailto:[email-masked]] 
Sent: Donnerstag, 8. August 2013 10:55
To: Schwarz, Albrecht (Albrecht)
Cc: ext Nevenka Biondic; [email-masked]; [email-masked]
Subject: Re: [Megaco] SDP attribute "a=imageattr:": (2) revised SDP O/A [3GPP CT4 "SIS-CT"]

Hello Albrecht,

I'm not sure using "*" for the PT would require the use of reserve value/group. My understanding is that it is simple shorthand if you have a list of payload. A MGC could provide an over specified list of payloads and utilise a=imageattr:*. The MG could response with a single payload and still have a=imageattr:* .

With respect to using "*" in the recv attr-list I'm not sure what this would indicate from a H.248 perspective. There seems to be a clash between the RFC6236 and the H.248 usage. RFC6236 indicates that "*" 
indicates that the user sees no reason to use the image attribute. 
Whereas the H.248 wildcard usage it would mean use "all" the values. I think this interaction is useful to specify. From a H.248 wildcarding perspective it would seem that "-" truly means the MGC doesn't care and "$" would mean provide a value.

There's also the issue of mapping the SDP to the local and remote descriptors. I take it that for H.248 you only specify a=imageattr:PT send attr-list or a=imageattr:PT recv attr-list depending on the descriptor.

Regards, Christian

On 7/08/2013 8:21 PM, Schwarz, Albrecht (Albrecht) wrote:
> 1.A "PT level" wildcard would imply multiple (reserved) media 
> 2.A "recv attr-list" level wildcard would enforce the MG to reply the 
> a.the wildcard "*" is applicable for SIP signalling, whereas the SDP 
> (here e.g., "$" and "-"); and
>
> 4.Example from 26.114 ("I've copied one below"):
> 26.116 is not using the "PT level" wildcard at all, because there's